<template>
    <Page>
        <ActionBar class="header">
            <StackLayout>
                <FlexboxLayout
                    flexDirection="row"
                    justifyContent="space-between" class="navbar"
                >
                    <Image
                        src="~/assets/images/menu.png"
                        class="menu"
                        stretch="fill"
                        @tap="$refs.drawer.nativeView.showDrawer()"
                    ></Image>
                    <Image
                        src="~/assets/images/logo.png"
                        class="logo"
                        stretch="fill"
                    ></Image>
                    <Image
                        src="~/assets/images/cloche.png"
                        class="bell"
                        stretch="fill"
                    ></Image>
                </FlexboxLayout>
            </StackLayout>
        </ActionBar>

        <RadSideDrawer ref="drawer">
            <StackLayout ~drawerContent backgroundColor="#ffffff">
                <DrawerContent/>
            </StackLayout>

            <StackLayout ~mainContent>
                <FlexboxLayout alignItems="center" class="back-button">
                    <Image src="~/assets/images/back.png" class="icon-margin" stretch="fill"></Image>
                    <Label class="back" text="Retour" @tap="$navigateBack"/>
                </FlexboxLayout>

                <ScrollView orientation="vertical">
                    <FlexboxLayout flexDirection="column" class="full-height">

                        <Label class="title" :text="listOfItems.adv_name"/>
                        <FlexboxLayout flexDirection="column" class="annonce-content">
                            <Label class="price-annonce" :text="'Prix : ' + listOfItems.adv_price + ' €/jour'"/>
                            <Label class="nbCrit-annonce"
                                   :text="'Nombre de personnes : ' + listOfItems.adv_cri_limit"/>
                            <Label class="address-annonce"
                                   :text="listOfItems.adv_adress + ', ' + listOfItems.adv_postal + ' ' + listOfItems.adv_city"/>
                            <Label class="description-annonce" :text="listOfItems.adv_describe" textWrap="true"/>
                        </FlexboxLayout>


                        <Label class="title" text="Réservations"/>
                        <FlexboxLayout flexDirection="row" class="annonce" v-for="item in reservList">
                            <FlexboxLayout flexDirection="column" class="annonce-content">
                                <Label class="titre-annonce"
                                       :text="'Réservation du ' + formatDate(item.res_date_start) + ' au ' + formatDate(item.res_date_end)"/>
                                <Label class="address-annonce"
                                       :text="'nombre de personnes : ' + item.res_adv_tenants"/>
                                <Label class="titre-annonce" text="contact :"/>
                                <Label class="reserv-annonce" :text="item.res_usr_mail"/>
                                <Label class="reserv-annonce" :text="'0'+item.res_usr_phone"/>
                            </FlexboxLayout>
                        </FlexboxLayout>

                    </FlexboxLayout>
                </ScrollView>
            </StackLayout>
        </RadSideDrawer>
    </Page>
</template>

<script>
import {Http} from "@nativescript/core";
import DrawerContent from "./DrawerContent";
import {Couchbase} from 'nativescript-couchbase-plugin';

const database = new Couchbase('atp_base');

export default {
    props: ['idAdvert'],
    components: {
        DrawerContent,
    },
    data() {
        return {
            listOfItems: {},
            reservList: [],
        }
    },
    mounted() {
        let db = database.query({select: []})
        this.user = db[0].userStore
        this.getAdvert()
        this.getReserv()
    },
    methods: {
        formatDate(date) {
            let dates = new Date(date)
            let year = dates.getFullYear()
            let month = (1 + dates.getMonth()).toString().padStart(2, '0');
            let day = dates.getDate().toString().padStart(2, '0')
            return day + '/' + month + '/' + year
        },
        async getAdvert() {
            const response = await Http.request({
                url: "https://api.atypikhouse.art/getAdvertbyId",
                method: "POST",
                headers: {
                    "Content-Type": "application/json",
                    "Access-Control-Allow-Origin": "*",
                },
                content: JSON.stringify({
                    adv_id: this.idAdvert
                }),
            })
            var result = response.content.toJSON();
            this.listOfItems = result.selectedAdvert[0];
        },
        async getReserv() {
            const response = await Http.request({
                url: "https://api.atypikhouse.art/getReservebyAdvert",
                method: "POST",
                headers: {
                    "Content-Type": "application/json",
                    "Access-Control-Allow-Origin": "*",
                },
                content: JSON.stringify({
                    adv_id: this.idAdvert,
                    usr_id: this.user.usr_id
                }),
            })
            var result = response.content.toJSON();
            for (let advert in result.userReserve) {
                this.reservList.push(result.userReserve[advert]);
            }
        },
    }
}
</script>

<style scoped>
.header {
    background-image: url("~/assets/images/header.png");
    background-size: cover;
    background-repeat: no-repeat;
    background-position: center;
    width: 100%;
}

.navbar {
    height: 120;
    width: 100%;
    padding-top: 30;
}

.menu {
    text-align: left;
    width: 40;
    margin-top: 13vh;
    margin-bottom: 40vh;
}

.logo {
    width: 70;
    height: 90px;
    margin-bottom: 20vh;
    justify-self: center;
}

.bell {
    text-align: right;
    width: 40vw;
    margin-top: 13vh;
    margin-bottom: 40vh;
    margin-right: 10;
}

.back-button {
    margin-left: 10;
    margin-top: 10;
}

.back {
    text-align: left;
    color: #2d2d2d;
}

.icon-margin {
    margin-right: 10;
    width: 16;
    height: 16;
}

.full-height {
    height: max-content;
    margin-left: 20vw;
    margin-right: 20vw;
    margin-top: 30vh;
}

.title {
    text-align: left;
    font-size: 25px;
    color: #2d2d2d;
    margin-bottom: 10;
    margin-top: 10;
}

.annonce {
    padding-top: 10;
    padding-bottom: 10;
    border-bottom-color: #7d7d7d;
    border-bottom-width: 2;
}

.titre-annonce {
    font-size: 16px;
    color: #2d2d2d;
}

.address-annonce {
    font-size: 14px;
    color: #7d7d7d;
    display: flex;
    flex-wrap: wrap;
}

.reserv-annonce {
    font-size: 14px;
    color: #7d7d7d;
    display: flex;
    flex-wrap: wrap;
}

</style>
